<div class="documentation-content-container">
  <button
    mat-flat-button
    color="accent"
    (click)="openDialog()"
    [disabled]="formDisabled$ | async"
  >
    select example data
  </button>
  <section class="mat-typography">
    <h2>Initial Input</h2>
    <p>
      Upload a list of molecules in .csv, .tsv, or .txt format according to OMEx
      specifications (click on "select example data" for more information).
    </p>
    <p>
      <b>Control group name</b> and <b>test group name</b> define the labels for
      the respecitve groups in subsequent plots. Currently only
      <b>two groups</b> are supported.
    </p>
    <p>
      <b>Control group prefix</b> and <b>test group prefix</b> should be set to
      the corresponding prefixes used in the column names of the input file.
    </p>
    <p>
      <b>Non-sparsity fraction</b> defines the minimum fraction of non-zero
      values one group should have. For example, a value of 0.66 means that at
      least 66% of the values in one group must be non-zero. Molecules below
      this threshold are not considered in the subsequent analysis.
    </p>
    <p>
      Checking <b>normalize data</b> includes sample normalization, i.e., every
      value is divided by the sum of the values in the respective sample column.
    </p>
    <p>
      Checking <b>split a test set from input data</b> separates a fraction of
      the data (specified in <b>test set fraction</b>) and excludes it from the
      molecule selection process. It is used in the final classification as an
      independent test set to evaluate classification performance based on the
      selected molecule panel.
    </p>
  </section>

  <div class="outer-form-container">
    <form [formGroup]="formModel" (ngSubmit)="submitOverviewConfig()">
      <div class="inner-form-container">
        <mat-form-field appearance="outline" class="w-full">
          <button
            type="button"
            mat-icon-button
            matPrefix
            (click)="f_input.click()"
            [disabled]="formDisabled$ | async"
          >
            <mat-icon>attach_file</mat-icon>
          </button>
          <input
            type="text"
            readonly
            matInput
            [formControl]="formModel.controls.inputCSVID"
            placeholder="Select File for Upload"
          />
          <input
            type="file"
            hidden
            #f_input
            (change)="handleFileInputChange(f_input.files)"
          />
          <mat-error *ngIf="formModel.get('data').invalid">{{
            getErrorMessage(formModel.get("data"))
          }}</mat-error>
        </mat-form-field>

        <div class="mb-4">
          <mat-divider></mat-divider>
        </div>

        <div formArrayName="groups">
          <div
            *ngFor="let group of groups.controls; index as i; first as isFirst"
          >
            <div *ngIf="isFirst" [formGroupName]="i" class="flex flex-col">
              <mat-form-field appearance="outline">
                <mat-label>control group name</mat-label>
                <input type="text" matInput formControlName="groupName" />
                <mat-error *ngIf="group.get('groupName').invalid">{{
                  getErrorMessage(group.get("groupName"))
                }}</mat-error>
              </mat-form-field>

              <mat-form-field appearance="outline">
                <mat-label>control group prefix</mat-label>
                <input type="text" matInput formControlName="groupPrefix" />
                <mat-error *ngIf="group.get('groupPrefix').invalid">{{
                  getErrorMessage(group.get("groupPrefix"))
                }}</mat-error>
              </mat-form-field>
            </div>

            <div *ngIf="!isFirst" [formGroupName]="i" class="flex flex-col">
              <div class="mb-4">
                <mat-divider></mat-divider>
              </div>

              <mat-form-field appearance="outline">
                <mat-label>test group name</mat-label>
                <input type="text" matInput formControlName="groupName" />
                <mat-error *ngIf="group.get('groupName').invalid">{{
                  getErrorMessage(group.get("groupName"))
                }}</mat-error>
              </mat-form-field>

              <mat-form-field appearance="outline">
                <mat-label>test group prefix</mat-label>
                <input type="text" matInput formControlName="groupPrefix" />
                <mat-error *ngIf="group.get('groupPrefix').invalid">{{
                  getErrorMessage(group.get("groupPrefix"))
                }}</mat-error>
              </mat-form-field>
            </div>

            <div *ngIf="i > 1" class="mb-4">
              <button
                [disabled]="formModel.disabled"
                mat-flat-button
                color="accent"
                type="button"
                (click)="removeGroup(i)"
              >
                delete this group
              </button>
            </div>
          </div>
        </div>
      </div>

      <div class="mb-4">
        <mat-divider></mat-divider>
      </div>

      <mat-form-field appearance="outline">
        <mat-label>non sparsity fraction</mat-label>
        <input
          type="number"
          step="0.01"
          matInput
          formControlName="sparsityFraction"
        />
        <mat-error *ngIf="formModel.get('sparsityFraction').invalid">{{
          getErrorMessage(formModel.get("sparsityFraction"))
        }}</mat-error>
      </mat-form-field>

      <div class="flex flex-row justify-start mb-8">
        <mat-checkbox formControlName="normalize">
          normalize data
        </mat-checkbox>
      </div>

      <div class="flex flex-row justify-start mb-8">
        <mat-checkbox formControlName="useTestset">
          split a test set from input data
        </mat-checkbox>
      </div>

      <mat-form-field appearance="outline">
        <mat-label>test set fraction</mat-label>
        <input
          type="number"
          step="0.01"
          matInput
          formControlName="testsetFraction"
        />
        <mat-error *ngIf="formModel.get('testsetFraction').invalid">{{
          getErrorMessage(formModel.get("testsetFraction"))
        }}</mat-error>
      </mat-form-field>

      <div class="form-button-grid">
        <button
          class="col-span-2"
          [disabled]="!formModel.valid || (formDisabled$ | async)"
          mat-flat-button
          color="accent"
        >
          Next
        </button>
      </div>
    </form>
  </div>

  <shared-notification-box
    [isWarning]="true"
    [message]="ofsJobMessage$ | async"
  ></shared-notification-box>
</div>
